diff -Nurp linux-2.4.22-clean/drivers/input/mousedev.c linux-2.4.22-adeos-ltt/drivers/input/mousedev.c
--- linux-2.4.22-clean/drivers/input/mousedev.c	2003-06-13 07:51:34.000000000 -0700
+++ linux-2.4.22-adeos-ltt/drivers/input/mousedev.c	2003-11-21 23:21:08.000000000 -0800
@@ -82,6 +82,10 @@ static struct mousedev mousedev_mix;
 static int xres = CONFIG_INPUT_MOUSEDEV_SCREEN_X;
 static int yres = CONFIG_INPUT_MOUSEDEV_SCREEN_Y;
 
+#ifdef CONFIG_MAC_EMUMOUSEBTN
+extern int mac_hid_mouse_emulate_buttons(int caller, unsigned int keycode, int down);
+#endif
+
 static void mousedev_event(struct input_handle *handle, unsigned int type, unsigned int code, int value)
 {
 	struct mousedev *mousedevs[3] = { handle->private, &mousedev_mix, NULL };
@@ -137,6 +141,11 @@ static void mousedev_event(struct input_
 						case BTN_MIDDLE: index = 2; break;	
 						default: return;
 					}
+
+#ifdef CONFIG_MAC_EMUMOUSEBTN
+				        index = mac_hid_mouse_emulate_buttons(2, index, 0);
+#endif
+
 					switch (value) {
 						case 0: clear_bit(index, &list->buttons); break;
 						case 1: set_bit(index, &list->buttons); break;
diff -Nurp linux-2.4.22-clean/drivers/Makefile linux-2.4.22-adeos-ltt/drivers/Makefile
--- linux-2.4.22-clean/drivers/Makefile	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/drivers/Makefile	2003-11-21 23:25:36.000000000 -0800
@@ -8,7 +8,7 @@
 
 mod-subdirs :=	dio hil mtd sbus video macintosh usb input telephony ide \
 		message/i2o message/fusion scsi md ieee1394 pnp isdn atm \
-		fc4 net/hamradio i2c acpi bluetooth
+		fc4 net/hamradio i2c acpi bluetooth adeos
 
 subdir-y :=	parport char block net sound misc media cdrom hotplug
 subdir-m :=	$(subdir-y)
@@ -40,6 +40,7 @@ subdir-$(CONFIG_PNP)		+= pnp
 subdir-$(CONFIG_ISDN_BOOL)	+= isdn
 subdir-$(CONFIG_ATM)		+= atm
 subdir-$(CONFIG_FC4)		+= fc4
+subdir-$(CONFIG_TRACE)		+= trace
 
 # CONFIG_HAMRADIO can be set without CONFIG_NETDEVICE being set  -- ch
 subdir-$(CONFIG_HAMRADIO)	+= net/hamradio
@@ -48,4 +49,6 @@ subdir-$(CONFIG_ACPI_BOOT)	+= acpi
 
 subdir-$(CONFIG_BLUEZ)		+= bluetooth
 
+subdir-$(CONFIG_ADEOS)		+= adeos
+
 include $(TOPDIR)/Rules.make
diff -Nurp linux-2.4.22-clean/drivers/s390/s390io.c linux-2.4.22-adeos-ltt/drivers/s390/s390io.c
--- linux-2.4.22-clean/drivers/s390/s390io.c	2003-08-25 04:44:42.000000000 -0700
+++ linux-2.4.22-adeos-ltt/drivers/s390/s390io.c	2003-11-21 23:21:08.000000000 -0800
@@ -60,6 +60,7 @@
 #include <linux/init.h>
 #include <linux/bootmem.h>
 #include <linux/ctype.h>
+#include <linux/trace.h>
 #ifdef CONFIG_PROC_FS
 #include <linux/proc_fs.h>
 #endif
@@ -2389,9 +2390,11 @@ do_IRQ (struct pt_regs regs)
 			}
 
 			irq_enter (cpu, irq);
+			TRACE_IRQ_ENTRY(irq, !(((regs).psw.mask&PSW_PROBLEM_STATE) != 0));
 			s390irq_spin_lock (irq);
 			s390_process_IRQ (irq);
 			s390irq_spin_unlock (irq);
+			TRACE_IRQ_EXIT();
 			irq_exit (cpu, irq);
 		}
 
diff -Nurp linux-2.4.22-clean/drivers/s390/s390mach.c linux-2.4.22-adeos-ltt/drivers/s390/s390mach.c
--- linux-2.4.22-clean/drivers/s390/s390mach.c	2003-08-25 04:44:42.000000000 -0700
+++ linux-2.4.22-adeos-ltt/drivers/s390/s390mach.c	2003-11-21 23:21:08.000000000 -0800
@@ -6,12 +6,14 @@
  *  S390 version
  *    Copyright (C) 2000 IBM Deutschland Entwicklung GmbH, IBM Corporation
  *    Author(s): Ingo Adlung (adlung@de.ibm.com)
+ *  Portions added by T. Halloran: (C) Copyright 2002 IBM Poughkeepsie, IBM Corporation
  */
 
 #include <linux/config.h>
 #include <linux/spinlock.h>
 #include <linux/init.h>
 #include <linux/slab.h>
+#include <linux/trace.h>
 #ifdef CONFIG_SMP
 #include <linux/smp.h>
 #endif
@@ -162,6 +164,8 @@ void s390_do_machine_check( void )
 {
 	int      crw_count;
 	mcic_t   mcic;
+        trapid_t ltt_interruption_code;
+        uint32_t ltt_old_psw;
 
 #ifdef S390_MACHCHK_DEBUG
 	printk( KERN_INFO "s390_do_machine_check : starting ...\n");
@@ -170,6 +174,14 @@ void s390_do_machine_check( void )
 	memcpy( &mcic,
 	        &S390_lowcore.mcck_interruption_code,
 	        sizeof(__u64));
+	memcpy( &ltt_interruption_code,
+	        &S390_lowcore.mcck_interruption_code,
+	        sizeof(__u64));
+	memcpy( &ltt_old_psw,
+	        &S390_lowcore.mcck_old_psw,
+	        sizeof(uint32_t));
+        ltt_old_psw &=  PSW_ADDR_MASK;
+        TRACE_TRAP_ENTRY(ltt_interruption_code,ltt_old_psw);
  		
 	if (mcic.mcc.mcd.sd) /* system damage */
 		s390_handle_damage("received system damage machine check\n");
diff -Nurp linux-2.4.22-clean/drivers/trace/Makefile linux-2.4.22-adeos-ltt/drivers/trace/Makefile
--- linux-2.4.22-clean/drivers/trace/Makefile	1969-12-31 16:00:00.000000000 -0800
+++ linux-2.4.22-adeos-ltt/drivers/trace/Makefile	2003-11-21 23:21:08.000000000 -0800
@@ -0,0 +1,17 @@
+#
+# Makefile for the kernel tracing drivers.
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now inherited from the
+# parent makes..
+#
+
+O_TARGET := trace_driver.o
+
+# Is it loaded as a module or as part of the kernel
+obj-$(CONFIG_TRACE) = tracer.o
+
+include $(TOPDIR)/Rules.make
